package com.eactive.eai.agent.osd;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.batch.osd.OutsideManager;
import com.eactive.eai.common.util.Logger;

/**
* 1. 기능 : Running중인 EAI Server의 메모리에 로딩된 OutsideManager의 정보 변경
* 2. 처리 개요 : OutsideManager에 OutsideVO추가
* 3. 주의사항
*
* @author
* @version  v 1.0.0
* @see  관련 기능을 참조
* @since
*/
public class RemoveOutsideCommand extends Command
{

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public RemoveOutsideCommand(String name) {
        super(name);
    }

    /**
    * 1. 기능 :  OutsideManager에 OutsideVO추가
    * 2. 처리 개요 : OutsideManager에 OutsideVO추가
    * 3. 주의사항
    *
    * @exception CommandException	Argument Type이 다르거나 Command 수행중 Excpetion이 발생할 경우
    **/
    public Object execute() throws CommandException
    {
        Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
        logger.info(this.name + " Agent 가 호출되었습니다.");

        if ( args == null || !(args instanceof String[]) ) {
            String msg = makeException("BECEAICAG001", null);
            logger.error(msg);
            throw new CommandException(msg);
        }
        
        String[] argArray = (String[]) args;
		String batchCode = argArray[0];
		String outCode  = argArray[1];
		
        try {
        	
        	OutsideManager manager = OutsideManager.getInstance();
        	
        	manager.removeOutsideInfo(batchCode, outCode);
        	manager.removeOutsideLinkInfo(batchCode, outCode);
        	
			logger.info(this.name + " Agent 가 성공적으로 완료되었습니다.");
            return "success";

        } catch (Exception e) {
            String msg = makeException("BECEAICAG002", e);
            logger.error(msg, e);
            throw new CommandException(msg);
        }
    }

}
